Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/create_restart.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/create_restart.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/create_restart.f90	(revision 5075)
@@ -434,64 +616,75 @@
 
             ELSE
-            !4-2-2 get value from coarse grid 
-
-               !4-2-2-1 compute domain on coarse grid
-               tl_dom0=create__restart_get_dom_index(tl_file, il_imin0, il_jmin0, &
-               &                                              il_imax0, il_jmax0)
-
-               !4-2-2-2 add extra band (if possible) to compute interpolation
+            !!! get value from coarse grid 
+
+               ! compute domain on coarse grid
+               tl_dom0=dom_init(tl_mpp,             &
+               &                il_imin0, il_imax0, &
+               &                il_jmin0, il_jmax0 )
+
+               ! add extra band (if possible) to compute interpolation
                CALL dom_add_extra(tl_dom0)
 
-               ! open mpp file on domain
-               !4-2-2-3 init mpp structure
-               tl_mpp=mpp_init(tl_file)
-
-               !4-2-2-4 get processor to be used
-               CALL mpp_get_use( tl_mpp, tl_dom0 )
-
-               !4-2-2-5 open mpp files
-               CALL iom_mpp_open(tl_mpp)
-
+               ! open mpp files
+               CALL iom_dom_open(tl_mpp, tl_dom0)
                ! for each variable of this file
-               DO jj=1,tl_multi%t_file(ji)%i_nvar
+               DO jj=1,tl_multi%t_mpp(ji)%t_proc(1)%i_nvar
+
+                  WRITE(*,'(2x,a,a)') "work on variable "//&
+                  &  TRIM(tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_name)
 
                   jvar=jvar+1
-                  cl_name=tl_multi%t_file(ji)%t_var(jj)%c_name
-                  print *,'work on ',trim(cl_name)
-                  !4-2-2-6 read variable over domain
-                  tl_var(jvar)=iom_mpp_read_var( tl_mpp, TRIM(cl_name), &
-                  &                              td_dom=tl_dom0 )
-
-                  !4-2-2-7 interpolate variable
+                  cl_name=tl_multi%t_mpp(ji)%t_proc(1)%t_var(jj)%c_name
+
+                  ! read variable over domain
+                  tl_var(jvar)=iom_dom_read_var(tl_mpp, TRIM(cl_name), tl_dom0)
+
+                  il_offset(:,:)=grid_get_fine_offset(tl_coord0, &
+                  &                                   il_imin0, il_jmin0, &
+                  &                                   il_imax0, il_jmax0, &
+                  &                                   tl_coord1, &
+                  &                                   id_rho=il_rho(:), &
+                  &                                   cd_point=TRIM(tl_var(jvar)%c_point))
+                  
+
+                  ! interpolate variable
                   CALL create_restart_interp(tl_var(jvar), tl_level(:), &
                   &                          il_rho(:), &
                   &                          id_offset=il_offset(:,:))
 
-                  !tl_att=att_init('add_offset',0.)
-                  !CALL var_move_att(tl_var(jvar), tl_att)
-                  !tl_att=att_init('scale_factor',1.)
-                  !CALL var_move_att(tl_var(jvar), tl_att)
-
-                  !4-2-2-8 remove extraband added to domain
+                  ! remove extraband added to domain
                   CALL dom_del_extra( tl_var(jvar), tl_dom0, il_rho(:) )
 
-                  !4-2-2-10 add attribute to variable
+                  ! add attribute to variable
                   tl_att=att_init('src_file',TRIM(fct_basename(tl_mpp%c_name)))
                   CALL var_move_att(tl_var(jvar), tl_att)
 
+                  tl_att=att_init('src_i-indices',(/il_imin0, il_imax0/))
+                  CALL var_move_att(tl_var(jvar), tl_att)
+
+                  tl_att=att_init('src_j-indices',(/il_jmin0, il_jmax0/))
+                  CALL var_move_att(tl_var(jvar), tl_att)
+
+                  IF( ANY(il_rho(:)/=1) )THEN
+                     tl_att=att_init("refinment_factor", &
+                     &               (/il_rho(jp_I),il_rho(jp_J)/))
+                     CALL var_move_att(tl_var(jvar), tl_att)
+                  ENDIF
+
                   ! clean structure
                   CALL att_clean(tl_att)
 
-                  !4-2-2-11 use mask
+                  ! use mask
                   CALL create_restart_mask(tl_var(jvar), tl_level(:))
 
-                  !4-2-2-12 add ghost cell
-                  CALL grid_add_ghost( tl_var(jvar), &
-                  &                    tl_dom0%i_ighost,tl_dom0%i_jghost )
+                  ! add ghost cell
+                  CALL grid_add_ghost( tl_var(jvar), il_xghost(:,:) )
+
 
                ENDDO
 
-               !4-2-2-2 close mpp file
-               CALL iom_mpp_close(tl_mpp)
+               ! close mpp file
+               CALL iom_dom_close(tl_mpp)
+
                ! clean structure
                CALL mpp_clean(tl_mpp)
@@ -500,29 +693,33 @@
             ENDIF
 
-            ! close file
-            CALL iom_close(tl_file)
             ! clean structure
-            CALL file_clean(tl_file)
+            CALL mpp_clean(tl_mpp)
          ENDIF
       ENDDO
    ENDIF
 
-   !5- use additional request
-   DO jvar=1,tl_multi%i_nvar
-
-         !5-1 forced min and max value
-         CALL var_limit_value(tl_var(jvar))
-
-         !5-2 filter
-         CALL filter_fill_value(tl_var(jvar))
-
-         !5-3 extrapolate
-         CALL extrap_fill_value(tl_var(jvar), id_iext=in_extrap, &
-         &                                    id_jext=in_extrap, &
-         &                                    id_kext=in_extrap)
+   il_nvar=tl_multi%i_nvar
+
+   ! clean
+   CALL multi_clean(tl_multi)
+   CALL mpp_clean(tl_coord0)
+
+   ! use additional request
+   DO jvar=1,il_nvar
+
+      ! forced min and max value
+      CALL var_limit_value(tl_var(jvar))
+
+      ! filter
+      CALL filter_fill_value(tl_var(jvar))
+
+      ! extrapolate
+      CALL extrap_fill_value(tl_var(jvar), id_iext=in_extrap, &
+      &                                    id_jext=in_extrap, &
+      &                                    id_kext=in_extrap)
 
    ENDDO
 
-   !6- create file
+   ! create file
    IF( in_niproc == 0 .AND. &
    &   in_njproc == 0 .AND. &
@@ -532,10 +729,18 @@
       in_nproc = 1
    ENDIF
-   tl_mppout=mpp_init( TRIM(cn_fileout), tl_var(1), &
-   &                   in_niproc, in_njproc, in_nproc, &
-   &                   cd_type=cn_type)
-
-   !6-1 add dimension
+
+   ! add dimension
    tl_dim(:)=var_max_dim(tl_var(:))
+
+   DO ji=1,il_nvar
+
+      IF( ALL(tl_var(ji)%t_dim(:)%i_len == tl_dim(:)%i_len) )THEN
+         tl_mppout=mpp_init( TRIM(cn_fileout), tl_var(ji), &
+         &                   in_niproc, in_njproc, in_nproc, &
+         &                   cd_type=cn_type)
+         EXIT
+      ENDIF
+
+   ENDDO
 
    DO ji=1,ip_maxdim
@@ -551,43 +756,61 @@
    ENDDO
 
-   !6-2 add variables
-
-   !IF( ALL( tl_dim(1:2)%l_use ) )THEN
-   !   ! add longitude
-   !   tl_lon=iom_read_var(tl_coord1,'longitude')
-
-   !   CALL mpp_add_var(tl_mppout, tl_lon)
-   !   CALL var_clean(tl_lon)
-
-   !   ! add latitude
-   !   tl_lat=iom_read_var(tl_coord1,'latitude')
-
-   !   CALL mpp_add_var(tl_mppout, tl_lat)
-   !   CALL var_clean(tl_lat)
-   !ENDIF
-
-   !IF( tl_dim(3)%l_use )THEN
-   !   ! add depth
-   !   CALL mpp_add_var(tl_mppout, tl_depth)
-   !   CALL var_clean(tl_depth)
-   !ENDIF
-
-   !IF( tl_dim(4)%l_use )THEN
-   !   ! add time
-   !   CALL mpp_add_var(tl_mppout, tl_time)
-   !   CALL var_clean(tl_time)
-   !ENDIF
+   ! add variables
+   IF( ALL( tl_dim(1:2)%l_use ) )THEN
+
+      ! open mpp files
+      CALL iom_mpp_open(tl_coord1)
+
+      ! add longitude
+      tl_lon=iom_mpp_read_var(tl_coord1,'longitude')
+      CALL mpp_add_var(tl_mppout, tl_lon)
+      CALL var_clean(tl_lon)
+
+      ! add latitude
+      tl_lat=iom_mpp_read_var(tl_coord1,'latitude')
+      CALL mpp_add_var(tl_mppout, tl_lat)
+      CALL var_clean(tl_lat)
+
+      ! close mpp files
+      CALL iom_mpp_close(tl_coord1)
+
+   ENDIF
+
+   IF( tl_dim(3)%l_use )THEN
+      IF( ASSOCIATED(tl_depth%d_value) )THEN
+         ! add depth
+         CALL mpp_add_var(tl_mppout, tl_depth)
+      ELSE
+         CALL logger_error("CREATE RESTART: no value for depth variable.")
+      ENDIF
+   ENDIF
+   IF( ASSOCIATED(tl_depth%d_value) ) CALL var_clean(tl_depth)
+
+   IF( tl_dim(4)%l_use )THEN
+      IF( ASSOCIATED(tl_time%d_value) )THEN
+         ! add time
+         CALL mpp_add_var(tl_mppout, tl_time)
+      ELSE
+         CALL logger_error("CREATE RESTART: no value for time variable.")
+      ENDIF
+   ENDIF
+   IF( ASSOCIATED(tl_time%d_value) ) CALL var_clean(tl_time)
 
    ! add other variable
-   DO jvar=1,tl_multi%i_nvar
-      CALL mpp_add_var(tl_mppout, tl_var(jvar))
-      CALL var_clean(tl_var(jvar))
+   DO jvar=1,il_nvar
+      ! check if variable already add
+      il_index=var_get_index(tl_mppout%t_proc(1)%t_var(:), tl_var(jvar)%c_name)
+      IF( il_index == 0 )THEN
+         CALL mpp_add_var(tl_mppout, tl_var(jvar))
+         CALL var_clean(tl_var(jvar))
+      ENDIF
    ENDDO
 
-   DO ji=1,4
-      CALL mpp_add_var(tl_mppout,tl_level(ji))
-   ENDDO
-
-   !6-3 add some attribute
+!   DO ji=1,4
+!      CALL grid_add_ghost( tl_level(ji), il_xghost(:,:) )
+!      CALL var_clean(tl_level(ji))
+!   ENDDO
+
+   ! add some attribute
    tl_att=att_init("Created_by","SIREN create_restart")
    CALL mpp_add_att(tl_mppout, tl_att)
@@ -616,20 +839,24 @@
    ENDIF
 
-   !6-4 create file
+   ! create file
    CALL iom_mpp_create(tl_mppout)
 
-   !6-5 write file
+   ! write file
    CALL iom_mpp_write_file(tl_mppout)
-
-   !6-6 close file
+   ! close file
    CALL iom_mpp_close(tl_mppout)
-   IF( cn_coord0 /= '' ) CALL iom_close(tl_coord0)
-
-   !7- clean
+
+   ! print
+   CALL mpp_print(tl_mppout)
+
+   ! clean
+   CALL att_clean(tl_att)
+   CALL var_clean(tl_var(:))
    DEALLOCATE(tl_var)
+   CALL var_clean(tl_level(:))
+   DEALLOCATE(tl_level)
 
    CALL mpp_clean(tl_mppout)
-   CALL file_clean(tl_coord1)
-   CALL file_clean(tl_coord0)
+   CALL mpp_clean(tl_coord1)
 
    ! close log file
@@ -637,60 +864,5 @@
    CALL logger_close()
 
-!> @endcode
 CONTAINS
-   !-------------------------------------------------------------------
-   !> @brief
-   !> 
-   !> @details 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION create_restart_level(td_level1)
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TFILE), INTENT(IN) :: td_level1
-
-      ! function
-      TYPE(TVAR), DIMENSION(4) :: create_restart_level
-
-      ! local variable
-      TYPE(TFILE)              :: tl_level1
-      TYPE(TVAR), DIMENSION(4) :: tl_var
-      TYPE(TMPP)               :: tl_mpplevel1
-
-      ! loop indices
-      !----------------------------------------------------------------
-
-      !0- compute domain
-      tl_dom1=dom_init(td_level1)
-
-      !1 init mpp structure
-      tl_level1=td_level1
-      tl_mpplevel1=mpp_init(tl_level1)
-      
-      CALL file_clean(tl_level1)
-
-      !2 get processor to be used
-      CALL mpp_get_use( tl_mpplevel1, tl_dom1 )
-
-      !3 open mpp files
-      CALL iom_mpp_open(tl_mpplevel1)
-      tl_var(jp_T)=iom_mpp_read_var(tl_mpplevel1,'tlevel',td_dom=tl_dom1)
-      tl_var(jp_U)=iom_mpp_read_var(tl_mpplevel1,'ulevel',td_dom=tl_dom1)
-      tl_var(jp_V)=iom_mpp_read_var(tl_mpplevel1,'vlevel',td_dom=tl_dom1)
-      tl_var(jp_F)=iom_mpp_read_var(tl_mpplevel1,'flevel',td_dom=tl_dom1)
-
-      !4 save result
-      create_restart_level(:)=tl_var(:)
-
-      !5 clean
-      CALL iom_mpp_close(tl_mpplevel1)
-      CALL mpp_clean(tl_mpplevel1)
-
-   END FUNCTION create_restart_level
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -699,21 +871,24 @@
    !> @details 
    !> A variable is create with the same name that the input variable, 
-   !> and with dimension of the coordinate file. 
-   !> Then the variable table of value is split into equal subdomain.
-   !> Each subdomain is fill with the linked value of the matrix.
+   !> and with dimension of the coordinate file.<br/> 
+   !> Then the variable array of value is split into equal subdomain.
+   !> Each subdomain is filled with the corresponding value of the matrix.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !>
-   !> @param[in] td_var : variable structure 
-   !> @param[in] td_coord : coordinate 
+   !> @param[in] td_var    variable structure 
+   !> @param[in] td_coord  coordinate file structure 
+   !> @param[in] id_nlevel number of vertical level  
+   !> @param[in] td_level  array of level on T,U,V,F point (variable structure) 
    !> @return variable structure 
    !-------------------------------------------------------------------
-   !> @code
-   FUNCTION create_restart_matrix(td_var, td_coord)
+   FUNCTION create_restart_matrix(td_var, td_coord, id_nlevel, td_level)
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) , INTENT(IN) :: td_var
-      TYPE(TFILE), INTENT(IN) :: td_coord
+      TYPE(TVAR)              , INTENT(IN) :: td_var
+      TYPE(TMPP)              , INTENT(IN) :: td_coord
+      INTEGER(i4)             , INTENT(IN) :: id_nlevel
+      TYPE(TVAR), DIMENSION(:), INTENT(IN) :: td_level
 
       ! function
@@ -721,10 +896,8 @@
 
       ! local variable
-      INTEGER(i4)                                        :: il_ighost
-      INTEGER(i4)                                        :: il_jghost
-      INTEGER(i4)      , DIMENSION(2)                    :: il_xghost
       INTEGER(i4)      , DIMENSION(3)                    :: il_dim
       INTEGER(i4)      , DIMENSION(3)                    :: il_size
       INTEGER(i4)      , DIMENSION(3)                    :: il_rest
+      INTEGER(i4)      , DIMENSION(2,2)                  :: il_xghost
 
       INTEGER(i4)      , DIMENSION(:)      , ALLOCATABLE :: il_ishape
@@ -734,7 +907,4 @@
       REAL(dp)         , DIMENSION(:,:,:,:), ALLOCATABLE :: dl_value
 
-      TYPE(TVAR)                                         :: tl_lon
-      TYPE(TVAR)                                         :: tl_lat
-      TYPE(TVAR)                                         :: tl_var
       TYPE(TDIM)       , DIMENSION(ip_maxdim)            :: tl_dim
 
@@ -745,25 +915,22 @@
       !----------------------------------------------------------------
 
-      !1- read output grid
-      tl_lon=iom_read_var(td_coord,'longitude')
-      tl_lat=iom_read_var(td_coord,'latitude')
-
-      !2- look for ghost cell
-      il_xghost(:)=grid_get_ghost( tl_lon, tl_lat )
-
-      il_ighost=il_xghost(1)*ig_ghost
-      il_jghost=il_xghost(2)*ig_ghost
-      
-      !3- write value on grid
-      !3-1 get matrix dimension
+      ! look for ghost cell
+      il_xghost(:,:)=grid_get_ghost( td_coord )
+
+      ! write value on grid
+      ! get matrix dimension
       il_dim(:)=td_var%t_dim(1:3)%i_len
-      !3-2 output dimension
-      tl_dim(:)=tl_lon%t_dim(:)
+
+      ! output dimension
+      tl_dim(jp_I:jp_J)=dim_copy(td_coord%t_dim(jp_I:jp_J))
+      IF( id_nlevel >= 1 )THEN
+         tl_dim(jp_K)=dim_init('Z',id_nlevel)
+      ENDIF
 
       ! remove ghost cell
-      tl_dim(1)%i_len=tl_dim(1)%i_len - 2*il_xghost(1)*ig_ghost
-      tl_dim(2)%i_len=tl_dim(2)%i_len - 2*il_xghost(2)*ig_ghost
-
-      !3-3 split output domain in N subdomain depending of matrix dimension 
+      tl_dim(jp_I)%i_len=tl_dim(jp_I)%i_len - SUM(il_xghost(jp_I,:))*ip_ghost
+      tl_dim(jp_J)%i_len=tl_dim(jp_J)%i_len - SUM(il_xghost(jp_J,:))*ip_ghost
+
+      ! split output domain in N subdomain depending of matrix dimension 
       il_size(:) = tl_dim(1:3)%i_len / il_dim(:)
       il_rest(:) = MOD(tl_dim(1:3)%i_len, il_dim(:))
@@ -776,5 +943,4 @@
       ! add rest to last cell
       il_ishape(il_dim(1)+1)=il_ishape(il_dim(1)+1)+il_rest(1)
-      
 
       ALLOCATE( il_jshape(il_dim(2)+1) )
@@ -794,5 +960,5 @@
       il_kshape(il_dim(3)+1)=il_kshape(il_dim(3)+1)+il_rest(3)
 
-      !3-3 write ouput table of value 
+      ! write ouput array of value 
       ALLOCATE(dl_value( tl_dim(1)%i_len, &
       &                  tl_dim(2)%i_len, &
@@ -815,160 +981,37 @@
       ENDDO
 
-      !3-4 initialise variable with value
-      tl_var=var_init(TRIM(td_var%c_name),dl_value(:,:,:,:))
+      ! keep attribute and type
+      create_restart_matrix=var_copy(td_var)
+      DEALLOCATE( create_restart_matrix%d_value )
+      ! save new dimension
+      create_restart_matrix%t_dim(:)=dim_copy(tl_dim(:))
+      ! add variable value
+      CALL var_add_value( create_restart_matrix, dl_value(:,:,:,:), &
+      &                   id_type=td_var%i_type)
 
       DEALLOCATE(dl_value)
 
-      !4- add ghost cell
-      CALL grid_add_ghost(tl_var,il_ighost,il_jghost)
-
-      !5- save result
-      create_restart_matrix=tl_var
+      ! use mask
+      CALL create_restart_mask(create_restart_matrix, td_level(:))
+
+      ! add ghost cell
+      CALL grid_add_ghost( create_restart_matrix, il_xghost(:,:) )
+
+      ! clean 
+      DEALLOCATE(il_ishape)
+      DEALLOCATE(il_jshape)
+      DEALLOCATE(il_kshape)
 
    END FUNCTION create_restart_matrix
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
+   !> This subroutine use mask to filled land point with _FillValue
    !> 
-   !> @details 
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
    !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_mask   mask variable structure
    !-------------------------------------------------------------------
-   !> @code
-   FUNCTION create__restart_get_dom_coord( td_file, td_coord, &
-   &                                       id_rho )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TFILE),               INTENT(IN) :: td_file
-      TYPE(TFILE),               INTENT(IN) :: td_coord
-      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
-
-      ! function
-      TYPE(TDOM) :: create__restart_get_dom_coord
-
-      ! local variable
-      INTEGER(i4)                 :: il_pivot
-      INTEGER(i4)                 :: il_perio
-
-      INTEGER(i4)                 :: il_imin
-      INTEGER(i4)                 :: il_imax
-      INTEGER(i4)                 :: il_jmin
-      INTEGER(i4)                 :: il_jmax
-
-      INTEGER(i4), DIMENSION(2,2,2) :: il_ind
-
-      TYPE(TFILE)                 :: tl_file
-
-      TYPE(TDOM)                  :: tl_dom
-      ! loop indices
-      !----------------------------------------------------------------
-
-      tl_file=td_file
-      !1- open file
-      CALL iom_open(tl_file)
-
-      ! get periodicity
-      il_pivot=grid_get_pivot(tl_file)
-      il_perio=grid_get_perio(tl_file,il_pivot)
-
-      tl_file%i_perio=il_perio
-
-      !2- compute file grid indices around coord grid
-      il_ind(:,:,:)=grid_get_coarse_index(tl_file, td_coord )
-
-      il_imin=il_ind(1,1,1) ; il_imax=il_ind(1,2,1)
-      il_jmin=il_ind(2,1,1) ; il_jmax=il_ind(2,2,1)
-
-      !3- check grid coincidence
-      CALL grid_check_coincidence( tl_file, td_coord, &
-      &                            il_imin, il_imax, &
-      &                            il_jmin, il_jmax, &
-      &                            id_rho(:) )
-
-      !4- compute domain
-      tl_dom=dom_init(tl_file,         &
-      &               il_imin, il_imax, &
-      &               il_jmin, il_jmax)
-
-      ! close file
-      CALL iom_close(tl_file)
-
-      ! save result
-      create__restart_get_dom_coord=tl_dom
-
-   END FUNCTION create__restart_get_dom_coord
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief
-   !> 
-   !> @details 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION create__restart_get_dom_index( td_file, id_imin, id_jmin, &
-   &                                                id_imax, id_jmax )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TFILE), INTENT(IN) :: td_file
-      INTEGER(i4), INTENT(IN) :: id_imin
-      INTEGER(i4), INTENT(IN) :: id_imax
-      INTEGER(i4), INTENT(IN) :: id_jmin
-      INTEGER(i4), INTENT(IN) :: id_jmax
-
-      ! function
-      TYPE(TDOM) :: create__restart_get_dom_index
-
-      ! local variable
-      INTEGER(i4)                 :: il_pivot
-      INTEGER(i4)                 :: il_perio
-
-      TYPE(TFILE)                 :: tl_file
-
-      TYPE(TDOM)                  :: tl_dom
-      ! loop indices
-      !----------------------------------------------------------------
-
-      ! init
-      tl_file=td_file
-      !1- open file
-      CALL iom_open(tl_file)
-
-      ! get periodicity
-      il_pivot=grid_get_pivot(tl_file)
-      il_perio=grid_get_perio(tl_file,il_pivot)
-
-      tl_file%i_perio=il_perio
-
-      !2- compute domain
-      tl_dom=dom_init(tl_file,         &
-      &               id_imin, id_imax, &
-      &               id_jmin, id_jmax)
-
-      ! close file
-      CALL iom_close(tl_file)
-
-      ! save result
-      create__restart_get_dom_index=tl_dom
-
-   END FUNCTION create__restart_get_dom_index
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief
-   !> This subroutine
-   !> 
-   !> @details 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !> @param[in] 
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE create_restart_mask( td_var, td_mask )
 
@@ -987,192 +1030,54 @@
       !----------------------------------------------------------------
 
-      IF( ANY(td_var%t_dim(1:2)%i_len /= td_mask(1)%t_dim(1:2)%i_len) )THEN
-         CALL logger_error("CREATE RESTART MASK: dimension differ between "//&
-         &                 "variable ("//&
-         &                 TRIM(fct_str(td_var%t_dim(1)%i_len))//","//&
-         &                 TRIM(fct_str(td_var%t_dim(2)%i_len))//&
-         &                 ") and level ("//&
-         &                 TRIM(fct_str(td_mask(1)%t_dim(1)%i_len))//","//&
-         &                 TRIM(fct_str(td_mask(1)%t_dim(2)%i_len))//")")
-      ELSE
-         ALLOCATE( il_mask(td_var%t_dim(1)%i_len, &
-         &                 td_var%t_dim(2)%i_len) )
-
-         SELECT CASE(TRIM(td_var%c_point))
-         CASE('T')
-            il_mask(:,:)=INT(td_mask(jp_T)%d_value(:,:,1,1))
-         CASE('U')
-            il_mask(:,:)=INT(td_mask(jp_U)%d_value(:,:,1,1))
-         CASE('V')
-            il_mask(:,:)=INT(td_mask(jp_V)%d_value(:,:,1,1))
-         CASE('F')
-            il_mask(:,:)=INT(td_mask(jp_F)%d_value(:,:,1,1))
-         END SELECT
-
-         DO jl=1,td_var%t_dim(4)%i_len
-            DO jk=1,td_var%t_dim(3)%i_len
-               WHERE( il_mask(:,:) < jk ) td_var%d_value(:,:,jk,jl)=99 !td_var%d_fill
-                  !.AND. &
-                  !&   td_var%d_value(:,:,jk,jl) == td_var%d_fill .OR. &
-                  !&   il_mask(:,:) < jk .AND. &
-                  !&   td_var%d_value(:,:,jk,jl) == 1 ) td_var%d_value(:,:,jk,jl)=99 !td_var%d_fill
+      IF( ALL(td_var%t_dim(1:2)%l_use) )THEN
+         IF( ANY(td_var%t_dim(1:2)%i_len /= td_mask(1)%t_dim(1:2)%i_len) )THEN
+            CALL logger_error("CREATE RESTART MASK: dimension differ between"//&
+            &                 " variable "//TRIM(td_var%c_name)//" ("//&
+            &                 TRIM(fct_str(td_var%t_dim(1)%i_len))//","//&
+            &                 TRIM(fct_str(td_var%t_dim(2)%i_len))//&
+            &                 ") and level ("//&
+            &                 TRIM(fct_str(td_mask(1)%t_dim(1)%i_len))//","//&
+            &                 TRIM(fct_str(td_mask(1)%t_dim(2)%i_len))//")")
+         ELSE
+            ALLOCATE( il_mask(td_var%t_dim(1)%i_len, &
+            &                 td_var%t_dim(2)%i_len) )
+
+            SELECT CASE(TRIM(td_var%c_point))
+            CASE('T')
+               il_mask(:,:)=INT(td_mask(jp_T)%d_value(:,:,1,1))
+            CASE('U')
+               il_mask(:,:)=INT(td_mask(jp_U)%d_value(:,:,1,1))
+            CASE('V')
+               il_mask(:,:)=INT(td_mask(jp_V)%d_value(:,:,1,1))
+            CASE('F')
+               il_mask(:,:)=INT(td_mask(jp_F)%d_value(:,:,1,1))
+            END SELECT
+
+            DO jl=1,td_var%t_dim(4)%i_len
+               DO jk=1,td_var%t_dim(3)%i_len
+                  WHERE( il_mask(:,:) < jk )
+                     td_var%d_value(:,:,jk,jl)=td_var%d_fill
+                  END WHERE
+               ENDDO
             ENDDO
-         ENDDO
-
-         DEALLOCATE( il_mask )
+
+            DEALLOCATE( il_mask )
+         ENDIF
       ENDIF
    END SUBROUTINE create_restart_mask
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This subroutine interpolate variable
    !> 
-   !> @details 
-   !>
    !> @author J.Paul
    !> - Nov, 2013- Initial Version
    !>
-   !> @param[in] 
+   !> @param[inout] td_var    variable structure 
+   !> @param[inout] td_level  fine grid level, array of variable structure
+   !> @param[in] id_rho       array of refinment factor
+   !> @param[in] id_offset    array of offset between fine and coarse grid
+   !> @param[in] id_iext      i-direction size of extra bands (default=im_minext)
+   !> @param[in] id_jext      j-direction size of extra bands (default=im_minext)
    !-------------------------------------------------------------------
-   !> @code
-   FUNCTION create_restart_extract(td_var, td_file, &
-   &                             td_coord)
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TVAR) , INTENT(IN) :: td_var  
-      TYPE(TFILE), INTENT(IN) :: td_file
-      TYPE(TFILE), INTENT(IN) :: td_coord
-
-      ! function
-      TYPE(TVAR) :: create_restart_extract
-
-      ! local variable
-      INTEGER(i4), DIMENSION(2,2,2) :: il_ind
-
-      INTEGER(i4) :: il_pivot
-      INTEGER(i4) :: il_perio
-
-      INTEGER(i4) :: il_imin
-      INTEGER(i4) :: il_jmin
-      INTEGER(i4) :: il_imax
-      INTEGER(i4) :: il_jmax
-
-      TYPE(TFILE) :: tl_file
-
-      TYPE(TMPP)  :: tl_mpp
-
-      TYPE(TATT)  :: tl_att
-
-      TYPE(TVAR)  :: tl_var
-      
-      TYPE(TDOM)  :: tl_dom
-      ! loop indices
-      !----------------------------------------------------------------
-
-      IF( td_file%i_id == 0 )THEN
-         CALL logger_error("CREATE RESTART EXTRACT: file "//&
-         &  TRIM(td_file%c_name)//" not opened ")
-      ELSE
-
-         !init
-         tl_file=td_file
-
-         !1- open file
-         CALL iom_open(tl_file)
-
-         ! get periodicity
-         il_pivot=grid_get_pivot(tl_file)
-         il_perio=grid_get_perio(tl_file,il_pivot)
-
-         tl_file%i_perio=il_perio
-
-         !2- compute file grid indices around coord grid
-         il_ind(:,:,:)=grid_get_coarse_index(tl_file, td_coord )
-
-         il_imin=il_ind(1,1,1) ; il_imax=il_ind(1,2,1)
-         il_jmin=il_ind(2,1,1) ; il_jmax=il_ind(2,2,1)
-   
-         !3- check grid coincidence
-         CALL grid_check_coincidence( tl_file, td_coord, &
-         &                            il_imin, il_imax, &
-         &                            il_jmin, il_jmax, &
-         &                            (/1, 1, 1/) )
-
-         !4- compute domain
-         tl_dom=dom_init(tl_file,         &
-         &               il_imin, il_imax, &
-         &               il_jmin, il_jmax)
-
-         ! close file
-         CALL iom_close(tl_file)
-
-         !5- read bathymetry on domain (ugly way to do it, have to work on it)
-         !5-1 init mpp structure
-         tl_mpp=mpp_init(tl_file)
-
-         CALL file_clean(tl_file)
-
-         !5-2 get processor to be used
-         CALL mpp_get_use( tl_mpp, tl_dom )
-
-         !5-3 open mpp files
-         CALL iom_mpp_open(tl_mpp)
-
-         !5-4 read variable on domain
-         tl_var=iom_mpp_read_var(tl_mpp,TRIM(td_var%c_name),td_dom=tl_dom)
-
-         !5-5 close mpp file
-         CALL iom_mpp_close(tl_mpp)
-
-         !6- add ghost cell
-         CALL grid_add_ghost(tl_var,tl_dom%i_ighost,tl_dom%i_jghost)
-
-         !7- check result
-         IF( ANY( tl_var%t_dim(:)%l_use .AND. &
-         &        tl_var%t_dim(:)%i_len /= td_coord%t_dim(:)%i_len) )THEN
-            CALL logger_debug("CREATE BATHY EXTRACT: "//&
-            &        "dimensoin of variable "//TRIM(td_var%c_name)//" "//&
-            &        TRIM(fct_str(tl_var%t_dim(1)%i_len))//","//&
-            &        TRIM(fct_str(tl_var%t_dim(2)%i_len))//","//&
-            &        TRIM(fct_str(tl_var%t_dim(3)%i_len))//","//&
-            &        TRIM(fct_str(tl_var%t_dim(4)%i_len)) )
-            CALL logger_debug("CREATE BATHY EXTRACT: "//&
-            &        "dimensoin of coordinate file "//&
-            &        TRIM(fct_str(td_coord%t_dim(1)%i_len))//","//&
-            &        TRIM(fct_str(td_coord%t_dim(2)%i_len))//","//&
-            &        TRIM(fct_str(td_coord%t_dim(3)%i_len))//","//&
-            &        TRIM(fct_str(td_coord%t_dim(4)%i_len)) )
-            CALL logger_fatal("CREATE BATHY EXTRACT: "//&
-            &  "dimensoin of extracted "//&
-            &  "variable and coordinate file dimension differ")
-         ENDIF
-
-         !8- add attribute to variable
-         tl_att=att_init('src_file',TRIM(fct_basename(tl_mpp%c_name)))
-         CALL var_move_att(tl_var, tl_att)         
-
-         !9- save result
-         create_restart_extract=tl_var
-
-         ! clean structure
-         CALL var_clean(tl_var)
-         CALL mpp_clean(tl_mpp)
-      ENDIF
-
-   END FUNCTION create_restart_extract
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief
-   !> This subroutine
-   !> 
-   !> @details 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !> @param[in] 
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE create_restart_interp( td_var, td_level,&
    &                                 id_rho,          &
@@ -1191,6 +1096,4 @@
 
       ! local variable
-      TYPE(TVAR)  :: tl_var
-
       INTEGER(i4) :: il_iext
       INTEGER(i4) :: il_jext
@@ -1198,7 +1101,4 @@
       ! loop indices
       !----------------------------------------------------------------
-
-      ! copy variable
-      tl_var=td_var
 
       il_iext=3
